Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp	(revision 1853)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp	(revision 1869)
@@ -1398,497 +1569,466 @@
    //----------------------------------------------------------------
 
-   void CField::solveGridReference(void)
-   TRY
-   {
-      if (grid_ref.isEmpty() && domain_ref.isEmpty() && axis_ref.isEmpty() && scalar_ref.isEmpty())
-      {
-        ERROR("CField::solveGridReference(void)",
-              << "A grid must be defined for field '" << getFieldOutputName() << "' .");
-      }
-      else if (!grid_ref.isEmpty() && (!domain_ref.isEmpty() || !axis_ref.isEmpty() || !scalar_ref.isEmpty()))
-      {
-        ERROR("CField::solveGridReference(void)",
-              << "Field '" << getFieldOutputName() << "' has both a grid and a domain/axis/scalar." << std::endl
-              << "Please define either 'grid_ref' or 'domain_ref'/'axis_ref'/'scalar_ref'.");
-      }
-
-      if (grid_ref.isEmpty())
-      {
-        std::vector<CDomain*> vecDom;
-        std::vector<CAxis*> vecAxis;
-        std::vector<CScalar*> vecScalar;
-        std::vector<int> axisDomainOrderTmp;
-
-        std::vector<CDomain*> vecDomRef;
-        std::vector<CAxis*> vecAxisRef;
-        std::vector<CScalar*> vecScalarRef;
-
+  void CField::solveGridReference(void)
+  TRY
+  {
+    if (grid_!=nullptr) return ; // already done
+
+    if (grid_ref.isEmpty() && domain_ref.isEmpty() && axis_ref.isEmpty() && scalar_ref.isEmpty())
+    {
+      ERROR("CField::solveGridReference(void)",
+            << "A grid must be defined for field '" << getFieldOutputName() << "' .");
+    }
+    else if (!grid_ref.isEmpty() && (!domain_ref.isEmpty() || !axis_ref.isEmpty() || !scalar_ref.isEmpty()))
+    {
+      ERROR("CField::solveGridReference(void)",
+            << "Field '" << getFieldOutputName() << "' has both a grid and a domain/axis/scalar." << std::endl
+            << "Please define either 'grid_ref' or 'domain_ref'/'axis_ref'/'scalar_ref'.");
+    }
+
+    if (grid_ref.isEmpty())
+    {
+      std::vector<CDomain*> vecDom;
+      std::vector<CAxis*> vecAxis;
+      std::vector<CScalar*> vecScalar;
+      std::vector<int> axisDomainOrderTmp;
+
+      std::vector<CDomain*> vecDomRef;
+      std::vector<CAxis*> vecAxisRef;
+      std::vector<CScalar*> vecScalarRef;
         
-        if (!domain_ref.isEmpty())
+      if (!domain_ref.isEmpty())
+      {
+        StdString tmp = domain_ref.getValue();
+        if (CDomain::has(domain_ref))
         {
-          StdString tmp = domain_ref.getValue();
-          if (CDomain::has(domain_ref))
-          {
-            vecDom.push_back(CDomain::get(domain_ref));
-            vecDomRef.push_back(CDomain::createDomain());
-            vecDomRef.back()->domain_ref=domain_ref;
-            axisDomainOrderTmp.push_back(2);
-          }
-          else  ERROR("CField::solveGridReference(void)",
-                      << "Invalid reference to domain '" << domain_ref.getValue() << "'.");
+          vecDom.push_back(CDomain::get(domain_ref));
+          vecDomRef.push_back(CDomain::createDomain());
+          vecDomRef.back()->domain_ref=domain_ref;
+          axisDomainOrderTmp.push_back(2);
         }
-
-        if (!axis_ref.isEmpty())
+        else  ERROR("CField::solveGridReference(void)",
+                    << "Invalid reference to domain '" << domain_ref.getValue() << "'.");
+      }
+
+      if (!axis_ref.isEmpty())
+      {
+        if (CAxis::has(axis_ref))
         {
-          if (CAxis::has(axis_ref))
-          {
-            vecAxis.push_back(CAxis::get(axis_ref));
-            vecAxisRef.push_back(CAxis::createAxis());
-            vecAxisRef.back()->axis_ref=axis_ref;
-            axisDomainOrderTmp.push_back(1);
-          }
-          else  ERROR("CField::solveGridReference(void)",
-                      << "Invalid reference to axis '" << axis_ref.getValue() << "'.");
+          vecAxis.push_back(CAxis::get(axis_ref));
+          vecAxisRef.push_back(CAxis::createAxis());
+          vecAxisRef.back()->axis_ref=axis_ref;
+          axisDomainOrderTmp.push_back(1);
         }
-
-        if (!scalar_ref.isEmpty())
+        else  ERROR("CField::solveGridReference(void)",
+                    << "Invalid reference to axis '" << axis_ref.getValue() << "'.");
+      }
+
+      if (!scalar_ref.isEmpty())
+      {
+        if (CScalar::has(scalar_ref))
         {
-          if (CScalar::has(scalar_ref))
-          {
-            vecScalar.push_back(CScalar::get(scalar_ref));
-            vecScalarRef.push_back(CScalar::createScalar());
-            vecScalarRef.back()->scalar_ref=scalar_ref;
-            axisDomainOrderTmp.push_back(0);
-          }
-          else ERROR("CField::solveGridReference(void)",
-                     << "Invalid reference to scalar '" << scalar_ref.getValue() << "'.");
+          vecScalar.push_back(CScalar::get(scalar_ref));
+          vecScalarRef.push_back(CScalar::createScalar());
+          vecScalarRef.back()->scalar_ref=scalar_ref;
+          axisDomainOrderTmp.push_back(0);
         }
+        else ERROR("CField::solveGridReference(void)",
+                   << "Invalid reference to scalar '" << scalar_ref.getValue() << "'.");
+      }
         
-        CArray<int,1> axisDomainOrder(axisDomainOrderTmp.size());
-        for (int idx = 0; idx < axisDomainOrderTmp.size(); ++idx)
-        {
-          axisDomainOrder(idx) = axisDomainOrderTmp[idx];
-        }
-
-        // Warning: the gridId shouldn't be set as the grid_ref since it could be inherited
-        StdString gridId = CGrid::generateId(vecDom, vecAxis, vecScalar,axisDomainOrder);
-        if (CGrid::has(gridId)) this->grid = CGrid::get(gridId);
-        else  this->grid = CGrid::createGrid(gridId, vecDomRef, vecAxisRef, vecScalarRef,axisDomainOrder);
-      }
-      else
-      {
-        if (CGrid::has(grid_ref)) this->grid = CGrid::get(grid_ref);
-        else  ERROR("CField::solveGridReference(void)",
-                     << "Invalid reference to grid '" << grid_ref.getValue() << "'.");
-      }
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::solveGridDomainAxisRef(bool checkAtt)
-   TRY
-   {
-     grid->solveDomainAxisRef(checkAtt);
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::solveCheckMaskIndex(bool doSendingIndex)
-   TRY
-   {
-     grid->checkMaskIndex(doSendingIndex);
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::solveTransformedGrid()
-   TRY
-   {
-     if (grid && !grid->isTransformed() && hasDirectFieldReference() && grid != getDirectFieldReference()->grid)
-     {
-       std::vector<CGrid*> grids;
-       // Source grid
-       grids.push_back(getDirectFieldReference()->grid);
-       // Intermediate grids
-       if (!grid_path.isEmpty())
-       {
-         std::string gridId;
-         size_t start = 0, end;
-
-         do
-         {
-           end = grid_path.getValue().find(',', start);
-           if (end != std::string::npos)
-           {
-             gridId = grid_path.getValue().substr(start, end - start);
-             start = end + 1;
-           }
-           else
-             gridId = grid_path.getValue().substr(start);
-
-           if (!CGrid::has(gridId))
-             ERROR("void CField::solveTransformedGrid()",
-                   << "Invalid grid_path, the grid '" << gridId << "' does not exist.");
-
-           grids.push_back(CGrid::get(gridId));
-         }
-         while (end != std::string::npos);
-       }
-       // Destination grid
-       grids.push_back(grid);
-
-       for (size_t i = 0, count = grids.size() - 1; i < count; ++i)
-       {
-         CGrid *gridSrc  = grids[i];
-         CGrid *gridDest = grids[i + 1];
-         if (!gridDest->isTransformed())
-           gridDest->transformGrid(gridSrc);
-       }
-     }
-     else if (grid && grid->hasTransform() && !grid->isTransformed())
-     {
-       // Temporarily deactivate the self-transformation of grid
-       // grid->transformGrid(grid);
-     }
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::solveGenerateGrid()
-   TRY
-   {
-     if (grid && !grid->isTransformed() && hasDirectFieldReference() && grid != getDirectFieldReference()->grid)
-       grid->completeGrid(getDirectFieldReference()->grid);
-     else
-       grid->completeGrid();
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::solveGridDomainAxisBaseRef()
-   TRY
-   {
-     grid->solveDomainAxisRef(false);
-     grid->solveDomainAxisBaseRef();
-   }
-   CATCH_DUMP_ATTR
-
-   ///-------------------------------------------------------------------
-
-   template <>
-   void CGroupTemplate<CField, CFieldGroup, CFieldAttributes>::solveRefInheritance(void)
-   TRY
-   {
-      if (this->group_ref.isEmpty()) return;
-      StdString gref = this->group_ref.getValue();
-
-      if (!CFieldGroup::has(gref))
-         ERROR("CGroupTemplate<CField, CFieldGroup, CFieldAttributes>::solveRefInheritance(void)",
-               << "[ gref = " << gref << "]"
-               << " invalid group name !");
-
-      CFieldGroup* group = CFieldGroup::get(gref);
-      CFieldGroup* owner = CFieldGroup::get(boost::polymorphic_downcast<CFieldGroup*>(this));
-      owner->setAttributes(group); // inherite of attributes of group reference
+      CArray<int,1> axisDomainOrder(axisDomainOrderTmp.size());
+      for (int idx = 0; idx < axisDomainOrderTmp.size(); ++idx)
+      {
+        axisDomainOrder(idx) = axisDomainOrderTmp[idx];
+      }
+
+      // Warning: the gridId shouldn't be set as the grid_ref since it could be inherited
+      StdString gridId = CGrid::generateId(vecDom, vecAxis, vecScalar,axisDomainOrder);
+      if (CGrid::has(gridId)) this->grid_ = CGrid::get(gridId);
+      else  this->grid_ = CGrid::createGrid(gridId, vecDomRef, vecAxisRef, vecScalarRef,axisDomainOrder);
+    }
+    else
+    {
+      if (CGrid::has(grid_ref)) this->grid_ = CGrid::get(grid_ref);
+      else  ERROR("CField::solveGridReference(void)",
+                   << "Invalid reference to grid '" << grid_ref.getValue() << "'.");
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::solveGridDomainAxisRef(bool checkAtt)
+  TRY
+  {
+    grid_->solveDomainAxisRef(checkAtt);
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::solveCheckMaskIndex(bool doSendingIndex)
+  TRY
+  {
+    grid_->checkMaskIndex(doSendingIndex);
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::solveTransformedGrid()
+  TRY
+  {
+    if (grid_ && !grid_->isTransformed() && hasDirectFieldReference() && grid_ != getDirectFieldReference()->grid_)
+    {
+      std::vector<CGrid*> grids;
+      // Source grid
+      grids.push_back(getDirectFieldReference()->grid_);
+      auto gridPath = getGridPath() ;
+      grids.insert(grids.begin(), gridPath.begin(), gridPath.end());
+
+      for (size_t i = 0, count = grids.size() - 1; i < count; ++i)
+      {
+        CGrid *gridSrc  = grids[i];
+        CGrid *gridDest = grids[i + 1];
+        if (!gridDest->isTransformed()) gridDest->transformGrid(gridSrc);
+      }
+    }
+    else if (grid_ && grid_->hasTransform() && !grid_->isTransformed())
+    {
+      // Temporarily deactivate the self-transformation of grid
+      // grid_->transformGrid(grid_);
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::solveGenerateGrid()
+  TRY
+  {
+    if (grid_ && !grid_->isTransformed() && hasDirectFieldReference() && grid_ != getDirectFieldReference()->grid_)
+      grid_->completeGrid(getDirectFieldReference()->grid_);
+    else grid_->completeGrid();
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::solveGridDomainAxisBaseRef()
+  TRY
+  {
+    grid_->solveDomainAxisRef(false);
+    grid_->solveDomainAxisBaseRef();
+  }
+  CATCH_DUMP_ATTR
+
+  ///-------------------------------------------------------------------
+
+  template <>
+  void CGroupTemplate<CField, CFieldGroup, CFieldAttributes>::solveRefInheritance(void)
+  TRY
+  {
+    if (this->group_ref.isEmpty()) return;
+    StdString gref = this->group_ref.getValue();
+
+    if (!CFieldGroup::has(gref))
+      ERROR("CGroupTemplate<CField, CFieldGroup, CFieldAttributes>::solveRefInheritance(void)",
+         << "[ gref = " << gref << "]"
+         << " invalid group name !");
+
+    CFieldGroup* group = CFieldGroup::get(gref);
+    CFieldGroup* owner = CFieldGroup::get(boost::polymorphic_downcast<CFieldGroup*>(this));
+    owner->setAttributes(group); // inherite of attributes of group reference
       
-      std::vector<CField*> allChildren  = group->getAllChildren();
-      std::vector<CField*>::iterator it = allChildren.begin(), end = allChildren.end();
-
-      for (; it != end; it++)
-      {
-         CField* child = *it;
-         if (child->hasId()) owner->createChild()->field_ref.setValue(child->getId());
-
-      }
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::scaleFactorAddOffset(double scaleFactor, double addOffset)
-   TRY
-   {
-     recvDataSrv = (recvDataSrv - addOffset) / scaleFactor;
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::invertScaleFactorAddOffset(double scaleFactor, double addOffset)
-   TRY
-   {
-     recvDataSrv = recvDataSrv * scaleFactor + addOffset;
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::outputField(CArray<double,1>& fieldOut)
-   TRY
-   { 
-      CArray<size_t,1>& outIndexClient = grid->localIndexToWriteOnClient_;
-      CArray<size_t,1>& outIndexServer = grid->localIndexToWriteOnServer_;
-      for (size_t idx = 0; idx < outIndexServer.numElements(); ++idx)
-      {
-        fieldOut(outIndexServer(idx)) = recvDataSrv(outIndexClient(idx));
-      }
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::inputField(CArray<double,1>& fieldIn)
-   TRY
-   {
-      CArray<size_t,1>& outIndexClient = grid->localIndexToWriteOnClient_;
-      CArray<size_t,1>& outIndexServer = grid->localIndexToWriteOnServer_;
-      for (size_t idx = 0; idx < outIndexServer.numElements(); ++idx)
-      {
-        recvDataSrv(outIndexClient(idx)) = fieldIn(outIndexServer(idx));
-      }
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::outputCompressedField(CArray<double,1>& fieldOut)
-   TRY
-   {
-      CArray<size_t,1>& outIndexClient = grid->localIndexToWriteOnClient_;
-      CArray<size_t,1>& outIndexServer = grid->localIndexToWriteOnServer_;
-      for (size_t idx = 0; idx < outIndexServer.numElements(); ++idx)
-      {
-        fieldOut((idx)) = recvDataSrv(outIndexClient(idx));
-      }
-   }
-   CATCH_DUMP_ATTR
-
-   ///-------------------------------------------------------------------
-
-   void CField::parse(xml::CXMLNode& node)
-   TRY
-   {
-      string newContent ;
-      SuperClass::parse(node);
-      if (node.goToChildElement())
-      {
-        do
-        {
-          if (node.getElementName() == "variable" || node.getElementName() == "variable_group") this->getVirtualVariableGroup()->parseChild(node);
-          else if (node.getElementName() == "expr") if (node.getContent(newContent)) content+=newContent ;
-        } while (node.goToNextElement());
-        node.goToParentElement();
-      }
-      if (node.getContent(newContent)) content=newContent ;
-    }
-   CATCH_DUMP_ATTR
-
-   /*!
-     This function retrieves Id of corresponding domain_ref and axis_ref (if any)
+    std::vector<CField*> allChildren  = group->getAllChildren();
+    std::vector<CField*>::iterator it = allChildren.begin(), end = allChildren.end();
+
+    for (; it != end; it++)
+    {
+      CField* child = *it;
+     if (child->hasId()) owner->createChild()->field_ref.setValue(child->getId());
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::scaleFactorAddOffset(double scaleFactor, double addOffset)
+  TRY
+  {
+    recvDataSrv = (recvDataSrv - addOffset) / scaleFactor;
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::invertScaleFactorAddOffset(double scaleFactor, double addOffset)
+  TRY
+  {
+    recvDataSrv = recvDataSrv * scaleFactor + addOffset;
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::outputField(CArray<double,1>& fieldOut)
+  TRY
+  { 
+    CArray<size_t,1>& outIndexClient = grid_->localIndexToWriteOnClient_;
+    CArray<size_t,1>& outIndexServer = grid_->localIndexToWriteOnServer_;
+    for (size_t idx = 0; idx < outIndexServer.numElements(); ++idx)
+    {
+      fieldOut(outIndexServer(idx)) = recvDataSrv(outIndexClient(idx));
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::inputField(CArray<double,1>& fieldIn)
+  TRY
+  {
+    CArray<size_t,1>& outIndexClient = grid_->localIndexToWriteOnClient_;
+    CArray<size_t,1>& outIndexServer = grid_->localIndexToWriteOnServer_;
+    for (size_t idx = 0; idx < outIndexServer.numElements(); ++idx)
+    {
+      recvDataSrv(outIndexClient(idx)) = fieldIn(outIndexServer(idx));
+    }
+  }
+  CATCH_DUMP_ATTR
+
+ void CField::outputCompressedField(CArray<double,1>& fieldOut)
+ TRY
+ {
+    CArray<size_t,1>& outIndexClient = grid_->localIndexToWriteOnClient_;
+    CArray<size_t,1>& outIndexServer = grid_->localIndexToWriteOnServer_;
+    for (size_t idx = 0; idx < outIndexServer.numElements(); ++idx)
+    {
+      fieldOut((idx)) = recvDataSrv(outIndexClient(idx));
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  ///-------------------------------------------------------------------
+
+  void CField::parse(xml::CXMLNode& node)
+  TRY
+  {
+    string newContent ;
+    SuperClass::parse(node);
+    if (node.goToChildElement())
+    {
+      do
+      {
+        if (node.getElementName() == "variable" || node.getElementName() == "variable_group") this->getVirtualVariableGroup()->parseChild(node);
+        else if (node.getElementName() == "expr") if (node.getContent(newContent)) content+=newContent ;
+      } while (node.goToNextElement());
+      node.goToParentElement();
+    }
+    if (node.getContent(newContent)) content=newContent ;
+  }
+  CATCH_DUMP_ATTR
+
+ /*!
+   This function retrieves Id of corresponding domain_ref and axis_ref (if any)
    of a field. In some cases, only domain exists but axis doesn't
    \return pair of Domain and Axis id
+  */
+  const std::vector<StdString>& CField::getRefDomainAxisIds()
+  TRY
+  {
+    CGrid* cgPtr = getRelGrid();
+    if (NULL != cgPtr)
+    {
+      std::vector<StdString>::iterator it;
+      if (!domain_ref.isEmpty())
+      {
+        std::vector<StdString> domainList = cgPtr->getDomainList();
+        it = std::find(domainList.begin(), domainList.end(), domain_ref.getValue());
+        if (domainList.end() != it) domAxisScalarIds_[0] = *it;
+      }
+
+      if (!axis_ref.isEmpty())
+      {
+        std::vector<StdString> axisList = cgPtr->getAxisList();
+        it = std::find(axisList.begin(), axisList.end(), axis_ref.getValue());
+        if (axisList.end() != it) domAxisScalarIds_[1] = *it;
+      }
+
+      if (!scalar_ref.isEmpty())
+      {
+        std::vector<StdString> scalarList = cgPtr->getScalarList();
+        it = std::find(scalarList.begin(), scalarList.end(), scalar_ref.getValue());
+        if (scalarList.end() != it) domAxisScalarIds_[2] = *it;
+      }
+    }
+    return (domAxisScalarIds_);
+  }
+  CATCH_DUMP_ATTR
+
+  CVariable* CField::addVariable(const string& id)
+  TRY
+  {
+    return vVariableGroup->createChild(id);
+  }
+  CATCH
+
+  CVariableGroup* CField::addVariableGroup(const string& id)
+  TRY
+  {
+    return vVariableGroup->createChildGroup(id);
+  }
+  CATCH
+
+  void CField::setContextClient(CContextClient* contextClient)
+  TRY
+  {
+    CContext* context = CContext::getCurrent();
+    client = contextClient;
+  
+    // A grid is sent by a client (both for read or write) or by primary server (write only)
+    if (context->getServiceType()==CServicesManager::GATHERER)
+    {
+      if (file->mode.isEmpty() || (!file->mode.isEmpty() && file->mode == CFile::mode_attr::write))
+        grid_->setContextClient(contextClient);
+    }
+    else if (context->getServiceType()==CServicesManager::CLIENT)
+      grid_->setContextClient(contextClient);
+  }
+  CATCH_DUMP_ATTR
+
+  CContextClient* CField::getContextClient()
+  TRY
+  {
+    return client;
+  }
+  CATCH
+
+  void CField::sendAddAllVariables(CContextClient* client)
+  TRY
+  {
+    std::vector<CVariable*> allVar = getAllVariables();
+    std::vector<CVariable*>::const_iterator it = allVar.begin();
+    std::vector<CVariable*>::const_iterator itE = allVar.end();
+
+    for (; it != itE; ++it)
+    {
+      this->sendAddVariable((*it)->getId(), client);
+      (*it)->sendAllAttributesToServer(client);
+      (*it)->sendValue(client);
+    }
+  }
+  CATCH_DUMP_ATTR
+
+  /*!
+   * Send all Attributes to server. This method is overloaded, since only grid_ref attribute
+   * must be sent to server and not domain_ref/axis_ref/scalar_ref. 
    */
-   const std::vector<StdString>& CField::getRefDomainAxisIds()
-   TRY
-   {
-     CGrid* cgPtr = getRelGrid();
-     if (NULL != cgPtr)
-     {
-       std::vector<StdString>::iterator it;
-       if (!domain_ref.isEmpty())
-       {
-         std::vector<StdString> domainList = cgPtr->getDomainList();
-         it = std::find(domainList.begin(), domainList.end(), domain_ref.getValue());
-         if (domainList.end() != it) domAxisScalarIds_[0] = *it;
-       }
-
-       if (!axis_ref.isEmpty())
-       {
-         std::vector<StdString> axisList = cgPtr->getAxisList();
-         it = std::find(axisList.begin(), axisList.end(), axis_ref.getValue());
-         if (axisList.end() != it) domAxisScalarIds_[1] = *it;
-       }
-
-       if (!scalar_ref.isEmpty())
-       {
-         std::vector<StdString> scalarList = cgPtr->getScalarList();
-         it = std::find(scalarList.begin(), scalarList.end(), scalar_ref.getValue());
-         if (scalarList.end() != it) domAxisScalarIds_[2] = *it;
-       }
-     }
-     return (domAxisScalarIds_);
-   }
-   CATCH_DUMP_ATTR
-
-   CVariable* CField::addVariable(const string& id)
-   TRY
-   {
-     return vVariableGroup->createChild(id);
-   }
-   CATCH
-
-   CVariableGroup* CField::addVariableGroup(const string& id)
-   TRY
-   {
-     return vVariableGroup->createChildGroup(id);
-   }
-   CATCH
-
-   void CField::setContextClient(CContextClient* contextClient)
-   TRY
-   {
-     CContext* context = CContext::getCurrent();
-     client = contextClient;
-  
-     // A grid is sent by a client (both for read or write) or by primary server (write only)
-     if (context->getServiceType()==CServicesManager::GATHERER)
-     {
-       if (file->mode.isEmpty() || (!file->mode.isEmpty() && file->mode == CFile::mode_attr::write))
-         grid->setContextClient(contextClient);
-     }
-     else if (context->getServiceType()==CServicesManager::CLIENT)
-       grid->setContextClient(contextClient);
-   }
-   CATCH_DUMP_ATTR
-
-   CContextClient* CField::getContextClient()
-   TRY
-   {
-     return client;
-   }
-   CATCH
-
-   void CField::sendAddAllVariables(CContextClient* client)
-   TRY
-   {
-     std::vector<CVariable*> allVar = getAllVariables();
-     std::vector<CVariable*>::const_iterator it = allVar.begin();
-     std::vector<CVariable*>::const_iterator itE = allVar.end();
-
-     for (; it != itE; ++it)
-     {
-       this->sendAddVariable((*it)->getId(), client);
-       (*it)->sendAllAttributesToServer(client);
-       (*it)->sendValue(client);
-     }
-   }
-   CATCH_DUMP_ATTR
-
-   /*!
-    * Send all Attributes to server. This method is overloaded, since only grid_ref attribute
-    * must be sent to server and not domain_ref/axis_ref/scalar_ref. 
-    */
     
-   void CField::sendAllAttributesToServer(CContextClient* client)
-   TRY
-   {
-     if (grid_ref.isEmpty())
-     {
-       grid_ref=grid->getId() ;
-       SuperClass::sendAllAttributesToServer(client) ;
-       grid_ref.reset();
-     }
-     else SuperClass::sendAllAttributesToServer(client) ;
-   }
-   CATCH_DUMP_ATTR
+  void CField::sendAllAttributesToServer(CContextClient* client)
+  TRY
+  {
+    if (grid_ref.isEmpty())
+    {
+      grid_ref=grid_->getId() ;
+      SuperClass::sendAllAttributesToServer(client) ;
+      grid_ref.reset();
+    }
+    else SuperClass::sendAllAttributesToServer(client) ;
+  }
+  CATCH_DUMP_ATTR
     
-   void CField::sendAddVariable(const string& id, CContextClient* client)
-   TRY
-   {
-      sendAddItem(id, (int)EVENT_ID_ADD_VARIABLE, client);
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::sendAddVariableGroup(const string& id, CContextClient* client)
-   TRY
-   {
-      sendAddItem(id, (int)EVENT_ID_ADD_VARIABLE_GROUP, client);
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::recvAddVariable(CEventServer& event)
-   TRY
-   {
-
-      CBufferIn* buffer = event.subEvents.begin()->buffer;
-      string id;
-      *buffer >> id;
-      get(id)->recvAddVariable(*buffer);
-   }
-   CATCH
-
-   void CField::recvAddVariable(CBufferIn& buffer)
-   TRY
-   {
-      string id;
-      buffer >> id;
-      addVariable(id);
-   }
-   CATCH_DUMP_ATTR
-
-   void CField::recvAddVariableGroup(CEventServer& event)
-   TRY
-   {
-
-      CBufferIn* buffer = event.subEvents.begin()->buffer;
-      string id;
-      *buffer >> id;
-      get(id)->recvAddVariableGroup(*buffer);
-   }
-   CATCH
-
-   void CField::recvAddVariableGroup(CBufferIn& buffer)
-   TRY
-   {
-      string id;
-      buffer >> id;
-      addVariableGroup(id);
-   }
-   CATCH_DUMP_ATTR
-
-   /*!
-    * Check on freq_off and freq_op attributes.
-    */
-   void CField::checkTimeAttributes(CDuration* freqOp)
-   TRY
-   {
-     bool isFieldRead  = file && !file->mode.isEmpty() && file->mode == CFile::mode_attr::read;
-     bool isFieldWrite = file && ( file->mode.isEmpty() ||  file->mode == CFile::mode_attr::write);
-     if (isFieldRead && !(operation.getValue() == "instant" || operation.getValue() == "once") )     
-       ERROR("void CField::checkTimeAttributes(void)",
-             << "Unsupported operation for field '" << getFieldOutputName() << "'." << std::endl
-             << "Currently only \"instant\" is supported for fields read from file.")
-
-     if (freq_op.isEmpty())
-     {
-       if (operation.getValue() == "instant")
-       {
-         if (isFieldRead || isFieldWrite) freq_op.setValue(file->output_freq.getValue());
-         else freq_op=*freqOp ;
-       }
-       else
-         freq_op.setValue(TimeStep);
-     }
-     if (freq_offset.isEmpty())
-       freq_offset.setValue(isFieldRead ? NoneDu : (freq_op.getValue() - TimeStep));
-   }
-   CATCH_DUMP_ATTR
-
-   /*!
-    * Returns string arithmetic expression associated to the field.
-    * \return if content is defined return content string, otherwise, if "expr" attribute is defined, return expr string.
-    */
-   const string& CField::getExpression(void)
-   TRY
-   {
-     if (!expr.isEmpty() && content.empty())
-     {
-       content = expr;
-       expr.reset();
-     }
-
-     return content;
-   }
-   CATCH_DUMP_ATTR
-
-   bool CField::hasExpression(void) const
-   TRY
-   {
-     return (!expr.isEmpty() || !content.empty());
-   }
-   CATCH
-
-   bool CField::hasGridMask(void) const
-   TRY
-   {
-     return (this->grid->hasMask());
-   }
-   CATCH
-
-   DEFINE_REF_FUNC(Field,field)
+  void CField::sendAddVariable(const string& id, CContextClient* client)
+  TRY
+  {
+    sendAddItem(id, (int)EVENT_ID_ADD_VARIABLE, client);
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::sendAddVariableGroup(const string& id, CContextClient* client)
+  TRY
+  {
+    sendAddItem(id, (int)EVENT_ID_ADD_VARIABLE_GROUP, client);
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::recvAddVariable(CEventServer& event)
+  TRY
+  {
+    CBufferIn* buffer = event.subEvents.begin()->buffer;
+    string id;
+    *buffer >> id;
+    get(id)->recvAddVariable(*buffer);
+  }
+  CATCH
+
+  void CField::recvAddVariable(CBufferIn& buffer)
+  TRY
+  {
+    string id;
+    buffer >> id;
+    addVariable(id);
+  }
+  CATCH_DUMP_ATTR
+
+  void CField::recvAddVariableGroup(CEventServer& event)
+  TRY
+  {
+    CBufferIn* buffer = event.subEvents.begin()->buffer;
+    string id;
+    *buffer >> id;
+    get(id)->recvAddVariableGroup(*buffer);
+  }
+  CATCH
+
+  void CField::recvAddVariableGroup(CBufferIn& buffer)
+  TRY
+  {
+    string id;
+    buffer >> id;
+    addVariableGroup(id);
+  }
+  CATCH_DUMP_ATTR
+
+  /*!
+   * Check on freq_off and freq_op attributes.
+   */
+  void CField::checkTimeAttributes(CDuration* freqOp)
+  TRY
+  {
+    bool isFieldRead  = file && !file->mode.isEmpty() && file->mode == CFile::mode_attr::read;
+    bool isFieldWrite = file && ( file->mode.isEmpty() ||  file->mode == CFile::mode_attr::write);
+    if (isFieldRead && !(operation.getValue() == "instant" || operation.getValue() == "once") )     
+      ERROR("void CField::checkTimeAttributes(void)",
+         << "Unsupported operation for field '" << getFieldOutputName() << "'." << std::endl
+         << "Currently only \"instant\" is supported for fields read from file.")
+
+    if (freq_op.isEmpty())
+    {
+      if (operation.getValue() == "instant")
+      {
+        if (isFieldRead || isFieldWrite) freq_op.setValue(file->output_freq.getValue());
+        else freq_op=*freqOp ;
+      }
+      else freq_op.setValue(TimeStep);
+    }
+    if (freq_offset.isEmpty()) freq_offset.setValue(isFieldRead ? NoneDu : (freq_op.getValue() - TimeStep));
+  }
+  CATCH_DUMP_ATTR
+
+  /*!
+   * Returns string arithmetic expression associated to the field.
+   * \return if content is defined return content string, otherwise, if "expr" attribute is defined, return expr string.
+   */
+  const string& CField::getExpression(void)
+  TRY
+  {
+    if (!expr.isEmpty() && content.empty())
+    {
+      content = expr;
+      expr.reset();
+    }
+
+    return content;
+  }
+  CATCH_DUMP_ATTR
+
+  bool CField::hasExpression(void) const
+  TRY
+  {
+    return (!expr.isEmpty() || !content.empty());
+  }
+  CATCH
+
+  bool CField::hasGridMask(void) const
+  TRY
+  {
+    return (this->grid_->hasMask());
+  }
+  CATCH
+
+  DEFINE_REF_FUNC(Field,field)
 } // namespace xios
